/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2021/2/5
* Description        : CH563 IAP Demo
*                      (1)CH56X Examples by KEIL;    
*                      (2)1Ϣ,256000bps;
*                      (3)TCP̼
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "main.h"
                                                                   //򳤶
/* һLEDڼʾĽ,͵ƽLED */

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }         /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                            /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                            /* LED ߵƽرLEDʾ */


/* ĻȫֱҪ壬е */
__align(16)UINT8    CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                         CH563NET_NUM_UDP,
                         CH563NET_NUM_TCP,
                         CH563NET_NUM_TCP_LISTEN,
                         CH563NET_NUM_TCP_SEG,
                         CH563NET_NUM_IP_REASSDATA,
                         CH563NET_NUM_PBUF,
                         CH563NET_NUM_POOL_BUF
                         };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                         };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];
												 

UINT8 Tcpdesip[4]={192,168,1,90};
UINT16 Tcpdesport=2000;
UINT16 Tcpsrcport=2000;
UINT8 update_socketid=0;   
UINT16 app_version=0;                                                                     //汾
UINT32 bin_length=0;  
bin_struct bin;

UINT32 Bin_Sum; 
UINT32 Bin_Check_Sum; 
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
	if(R32_INT_FLAG & 0x8000)                                                   /* ̫ж */
	{                                                                           /* ̫жжϷ */
		CH563NET_ETHIsr();
	}
	if(R32_INT_FLAG & RB_IF_TMR0)                                               /* ʱж */
	{
		 CH563NET_TimeIsr(CH563NETTIMEPERIOD);                                  /* ʱжϷ */
		 R8_TMR0_INT_FLAG |= 0xff;                                              /* ʱжϱ־ */
	}
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
	UINT8 i = 0;
	R32_PB_PU |= (1<<7);
	R32_PB_DIR &= (1<<7);
	Uart_Debug_Init( );                                                              /* Ϊüͨڼʾ */
	printf("Start\n");
	i = CH56X_GetMac(MACAddr);    
   i = CH563NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */                      /* ʼ */
	mStopIfError(i);                                                            /*  */
	
	printf("CH563IPLibInit Success\n");
	
	SysTimeInit();                                                              /* ϵͳʱʼ */
	InitSysHal();                                                               /* ʼж */
	printf("start_while(1)\n");
	while(1)
	{
		CH563NET_MainTask();                                                    /* CH563NETҪѭвϵ */
		if(CH563NET_QueryGlobalInt())CH563NET_HandleGlobalInt();                /* ѯжϣжϣȫжϴ */			
		if((R32_PB_PIN & (1<<7)) == 0)
		{
			CH563NET_CreatTcpSocket();	
		}
		if(update_flag == 2)
		{
				Writebin_to_Flash();
		}		
	}
}


/*******************************************************************************
* Function Name  : Writebin_to_Flash
* Description    : BinļFLASH洢
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void Writebin_to_Flash()
{
	UINT32 len;
	UINT8 i;
	UINT8 flag[2]={0x57,0xab};

	if(bin.remain_len>=512)
	{
		len=512; 			
		i = FLASH_ROM_WRITE( bin_addr ,(PVOID)&(bin.buf[bin.p_send]),len );                     //û򣬴flash_addrַʼ                                                                              
		if(i) printf("*****Write error*****\r\n"); 
		else	printf("*****Write ok*****\r\n"); 				
		i = FLASH_ROM_VERIFY( bin_addr ,(PVOID)&(bin.buf[bin.p_send]),len );                    // УǷȷ                                                                            
		if(i) printf("*****Verify error*****\r\n");  
		else	printf("*****Verify ok*****\r\n"); 
		bin_addr+=len;
		bin_length-=len;
		bin.p_send+=len;
		bin.remain_len-=len;
		if(bin.p_send>=bin_bufsize)
		bin.p_send=0;			
		if(bin_length==0)
		{
			printf("update over \r\n");					
			update_flag=3; 
			EEPROM_ERASE( 20*1024, 4096 );  
			printf("Bin_Check_Sum:%08x\r\n",Bin_Check_Sum);			
			printf("Bin_Sum:%08x\r\n",Bin_Sum);			
			if(Bin_Check_Sum == Bin_Sum)
			{
				EEPROM_WRITE( 20*1024, flag, 2 );	

			}
			Bin_Check_Sum = 0;
			Bin_Sum = 0;
		}								
	}
	else
	{			
		if(bin_length!=bin.remain_len) return;					
		len=bin.remain_len;
		i = FLASH_ROM_WRITE( bin_addr ,(PVOID)&(bin.buf[bin.p_send]),len );                     //û򣬴flash_addrַʼ                                                                              
		if(i) printf("*****Write error*****\r\n"); 
		else	printf("*****Write ok*****\r\n"); 				
		i = FLASH_ROM_VERIFY( bin_addr ,(PVOID)&(bin.buf[bin.p_send]),len );                    // УǷȷ                                                                            
		if(i) printf("*****Verify error*****\r\n");  
		else	printf("*****Verify ok*****\r\n"); 
					bin_addr+=len;
		printf("update over \r\n");			
		update_flag=3; 
		EEPROM_ERASE( 20*1024, 4096 );  		
		printf("Bin_Check_Sum:%08x\r\n",Bin_Check_Sum);			
		printf("Bin_Sum:%08x\r\n",Bin_Sum);			
		if(Bin_Check_Sum == Bin_Sum)
		{
			EEPROM_WRITE( 20*1024, flag, 2 );	

		}	
		Bin_Check_Sum = 0;
		Bin_Sum = 0;
	}
}




/*********************************** endfile **********************************/
