#include "ch563_gpio.h"


/*******************************************************************************
* Function Name  : IRQ_InitPB
* Description    : жóʼ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void IRQ_InitPB( void )
{
    R32_PB_PU  |= 0x00000020;                                                   /* GPIO Bã1ʾ */ 
    R32_PB_DIR &= ~0x00000020;                                                  /* GPIO BΪ , direction: 0=in, 1=out */

    R32_INT_ENABLE_PB |= 0x00000020;                                            /* GPIO Bλжʹ  1-ʹܣ0-ֹ */
    R32_INT_MODE_PB   |= 0x00000020;                                            /* GPIO BжϷʽ 1-ж,0-ƽж */      
    R32_INT_POLAR_PB  &= ~0x00000020;                                           /* GPIO Bжϼ 1-ж/ߵƽ0-½ж/͵ƽ */      
    
    R32_INT_STATUS_PB  = 0xfffff;                                               /* жϱ־д1 */
    R8_INT_EN_IRQ_1   |= RB_IE_IRQ_PB;                                          /* GPIO Bжʹ */     
}

/*******************************************************************************
* Function Name  : Timer3_Init
* Description    : ʱ0ʼ
* Input          : end  -ʱ3ʱڣʱTime = Pclk*end, PclkΪϵͳʱ
*                  fifo -PWMռձ
* Output         : None
* Return         : None
*******************************************************************************/

void Timer3_Init( void )  
{
		R8_TMR3_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR3_COUNT = 0x00000000; 
    R32_TMR3_CNT_END =0x186a0 * 100;                            
    R8_TMR3_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR3_CTRL_MOD = RB_TMR_COUNT_EN;
}

/*******************************************************************************
* Function Name  : Timer3_IRQ_Init
* Description    : IRQжϳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void Timer3_IRQ_Init( void )
{    
    R8_TMR3_INT_FLAG=0xff;                                                      /* ежϱ־ */                                                               
    R8_TMR3_INTER_EN=RB_TMR3_FORCE_EN|RB_TMR_IE_CYC_END|RB_TMR_IE_DATA_ACT;     /* ʱʱڽжʹܣPWM жʹ */
    R8_INT_EN_IRQ_0=RB_IE_IRQ_TMR3;                                             /* ʱ0жϲ */
//    R8_INT_EN_IRQ_GLOB= RB_IE_IRQ_GLOB;                                         /* ֻIRQȫж */
	   
}
