
#include "main.h"
/* ʾغ */
#define RECE_BUF_LEN                          1600                              /* ջĴС */

/* CH563ض */
UINT8 MACAddr[6] = {0x02,0x03,0x04,0x05,0x06,0x07};                             /* CH563MACַ */
UINT8 IPAddr[4] = {192,168,1,2};                                          /* CH563IPַ */
UINT8 GWIPAddr[4] = {192,168,1,1};                                        /* CH563 */
UINT8 IPMask[4] = {255,255,255,0};                                        /* CH563 */
UINT8 SocketId;                                                                 /* socketԲö */
UINT8 SocketRecvBuf[2][RECE_BUF_LEN];                                              /* socketջ */
UINT8 MyBuf[RECE_BUF_LEN];                                                      /* һʱ */

UINT32 *length;
UINT32 len1=1260;
UINT8 udp_receive_flag=0;
//UDP
UINT8 rec_length=0;
UINT8 Rec_Buf_Solve[50];


UINT8 update_flag=0;
UINT32 bin_addr=64*1024;

UINT32 tlen=0;
extern UINT32 Bin_Sum; 
extern UINT32 Bin_Check_Sum; 






UINT32 RX_Check_Sum(UINT8* buf , UINT16 length)
{
	UINT16 c;
	UINT32 ret = 0;
	for(c=0;c<length;c++)
	{
		ret +=(UINT32) *(buf++);
	}
	return ret;
}
/*******************************************************************************
* Function Name  : Timer2_Init
* Description    : ʱ0ʼ
* Input          : end  -ʱ0ʱڣʱTime = Pclk*end, PclkΪϵͳʱ
*                  fifo -PWMռձ
* Output         : None
* Return         : None
*******************************************************************************/

void SysTimeInit( void )  
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NETTIMEPERIOD;                            /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}




/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM2ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR2;                                          /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                           /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                 /* ɹ */
#if CH563NET_DBG
    printf("Error: %02X\n", (UINT16)iError);                                    /* ʾ */
#endif    
}

/*******************************************************************************
* Function Name  : CH563NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                 : mask    ָ
*                 : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
    UINT8 i;
    struct _CH563_CFG cfg;
    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
    CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    return (i);                      /* ʼ */
}


/*******************************************************************************
* Function Name  : CH563NET_HandleSockInt
* Description    : Socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;
	  UINT8 i;

    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
		len = CH563NET_SocketRecvLen(sockeid,NULL);                             /* Ὣǰָ봫ݸprecv*/
		if(update_flag==1)                                                                                                       
		{
			if(len>=16)
			{
				len=16;
				CH563NET_SocketRecv(sockeid,MyBuf,&len);                                /* ջݶMyBuf*/
				CH563NET_SocketSend(sockeid,MyBuf,&len); 
				if( (MyBuf[0]==0XAA) && (MyBuf[1]==0XBB))
				{							
					app_version= ((UINT16)MyBuf[2]<<8) +	(UINT16)MyBuf[3];
					bin_length= ((UINT32)MyBuf[4]<<24) + ((UINT32)MyBuf[5]<<16) + ((UINT32)MyBuf[6]<<8)+ ((UINT32)MyBuf[7]);	
					Bin_Sum = ((UINT32)MyBuf[8]<<24) + ((UINT32)MyBuf[9]<<16) + ((UINT32)MyBuf[10]<<8)+ ((UINT32)MyBuf[11]);						
					update_flag=2;
					bin_addr=64*1024;
					bin.p_recv=0;
					bin.p_send=0;
					bin.remain_len=0;
					printf("app_version=%d\r\n",app_version);
					printf("bin_length=%d\r\n",bin_length);		
					FLASH_ROM_LOCK( 0x00 );                                              // FLASH							
					i=FLASH_ROM_ERASE(bin_addr,64*1024);
					if(i) printf("*****Erase error*****\r\n"); 
					else	 printf("*****Erase ok*****\r\n"); 						
					
				}
			}
		}
		else if(update_flag==2)       					
		{ 
			if(bin.remain_len<bin_bufsize)
			{						
				if(bin.p_recv+len<=bin_bufsize)
				{
					CH563NET_SocketRecv(sockeid,&bin.buf[bin.p_recv],&len);
					Bin_Check_Sum += RX_Check_Sum(&bin.buf[bin.p_recv], len);
					bin.p_recv+=len;						
				}
				else
				{
					len=bin_bufsize-bin.p_recv;
					CH563NET_SocketRecv(sockeid,&bin.buf[bin.p_recv],&len);
					Bin_Check_Sum += RX_Check_Sum(&bin.buf[bin.p_recv], len);
					bin.p_recv=0;							
				}						 
						bin.remain_len+=len;	
						tlen+=len;					
			}
		}
	}

	if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
	{
		printf("tcp connect success\r\n");
		update_flag=1;
	}
	if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
	{
		printf("tcp disconnect \r\n");
		update_flag=0;
	}
	if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
	{
		if(sockeid==update_socketid && sockeid != 0)
		{
			printf("tcp  time out \r\n");
			update_flag=0;
			CH563NET_CreatTcpSocket();
		}
	}
}

/*******************************************************************************
* Function Name  : CH563NET_HandleGloableInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    
    initstat = CH563NET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
#if CH563NET_DBG
        printf("UnreachCode %d\n",CH563Inf.UnreachCode);                      /* 鿴ɴ */
        printf("UnreachProto %d\n",CH563Inf.UnreachProto);                    /* 鿴ɴЭ */
        printf("UnreachPort %d\n",CH563Inf.UnreachPort);                      /* ѯɴ˿ */
#endif       
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       i = CH563NET_GetPHYStatus();                                             /* ȡPHY״̬ */
#if CH563NET_DBG
       printf("GINT_STAT_PHY_CHANGE %02x\n",i);
#endif   
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH563NET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH563NET_HandleSockInt(i,socketinit);                  /* ж */
       }    
   }
}



/*******************************************************************************
* Function Name  : CH563NET_CreatUdpSocket
* Description    : UDP socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_CreatTcpSocket(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,Tcpdesip,4);                              /* ĿIPַ */
   TmpSocketInf.DesPort = Tcpdesport;                                           /* ĿĶ˿ */
   TmpSocketInf.SourPort = Tcpsrcport;                                        /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf[1];                      /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */ 
   mStopIfError(i);                                                             /*  */
	
	 update_socketid=SocketId;
	 i = CH563NET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */

	
}

